> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Post invoices

POST https://rest.test.zuora.com/v1/invoices/bulk-post
Content-Type: application/json

Posts multiple invoices.

You can post a maximum of 50 invoices in one single request. Additionally, you can also update invoice dates while posting the invoices.
**Note** : This operation is synchronous and invoices within the bulk request are posted one by one.  The maximum batch size depends on the posting performance, which varies with invoice complexity and integrations with external tax engines.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/invoices/post-post-invoices

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTInvoicesBatchPostType.

- `invoices` (list of InvoicePostType, optional) — The container for invoices to be posted. The maximum number of invoices to be posted is 50 in one request.

## Response

### 200

OK

- `invoices` (list of InvoicePostResponseType, optional) — The container for a list of posted invoices.
- `success` (boolean, optional) — Returns `true` if the request has one of invoices was posted successfully.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### InvoicePostType

Container for custom fields of an Invoice object.

- `id` (string, optional) — The ID of the invoice to be posted.
- `invoiceDate` (date, optional) — The date that appears on the invoice being created, in `yyyy-mm-dd` format. The value cannot fall in a closed accounting period.

### InvoicePostResponseType

- `id` (string, optional) — The ID of the invoice that was posted.
- `success` (boolean, optional) — Returns `true` if the invoice was posted successfully.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "invoices": [
    {
      "id": "402890555a7e9791015a7f15fe440123",
      "invoiceDate": "2022-10-12",
      "complexity__c": "Middle",
      "description__c": "description"
    },
    {
      "id": "402890555a7e9791015a7f15fe44013a",
      "invoiceDate": "2022-10-12",
      "complexity__c": "Middle",
      "description__c": "description"
    },
    {
      "id": "402890555a7e9791015a7f15fe44012b",
      "invoiceDate": "2022-10-12",
      "complexity__c": "Middle",
      "description__c": "description"
    }
  ]
}
```

**Response**

```json
{
  "invoices": [
    {
      "id": "402890555a7e9791015a7f15fe440123",
      "success": true
    },
    {
      "id": "402890555a7e9791015a7f15fe44013a",
      "success": true
    },
    {
      "id": "ff808081804f25b001804f2d8971079f",
      "success": false,
      "processId": "F3D4DAF98E6CE569",
      "reasons": [
        {
          "code": 59210020,
          "message": "Only invoices with Draft status can be posted."
        }
      ]
    }
  ],
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/invoices/bulk-post"

payload = { "invoices": [
        {
            "id": "402890555a7e9791015a7f15fe440123",
            "invoiceDate": "2022-10-12",
            "complexity__c": "Middle",
            "description__c": "description"
        },
        {
            "id": "402890555a7e9791015a7f15fe44013a",
            "invoiceDate": "2022-10-12",
            "complexity__c": "Middle",
            "description__c": "description"
        },
        {
            "id": "402890555a7e9791015a7f15fe44012b",
            "invoiceDate": "2022-10-12",
            "complexity__c": "Middle",
            "description__c": "description"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/invoices/bulk-post';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"invoices":[{"id":"402890555a7e9791015a7f15fe440123","invoiceDate":"2022-10-12","complexity__c":"Middle","description__c":"description"},{"id":"402890555a7e9791015a7f15fe44013a","invoiceDate":"2022-10-12","complexity__c":"Middle","description__c":"description"},{"id":"402890555a7e9791015a7f15fe44012b","invoiceDate":"2022-10-12","complexity__c":"Middle","description__c":"description"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/invoices/bulk-post"

	payload := strings.NewReader("{\n  \"invoices\": [\n    {\n      \"id\": \"402890555a7e9791015a7f15fe440123\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    },\n    {\n      \"id\": \"402890555a7e9791015a7f15fe44013a\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    },\n    {\n      \"id\": \"402890555a7e9791015a7f15fe44012b\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/invoices/bulk-post")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"invoices\": [\n    {\n      \"id\": \"402890555a7e9791015a7f15fe440123\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    },\n    {\n      \"id\": \"402890555a7e9791015a7f15fe44013a\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    },\n    {\n      \"id\": \"402890555a7e9791015a7f15fe44012b\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/invoices/bulk-post")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"invoices\": [\n    {\n      \"id\": \"402890555a7e9791015a7f15fe440123\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    },\n    {\n      \"id\": \"402890555a7e9791015a7f15fe44013a\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    },\n    {\n      \"id\": \"402890555a7e9791015a7f15fe44012b\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    }\n  ]\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/invoices/bulk-post', [
  'body' => '{
  "invoices": [
    {
      "id": "402890555a7e9791015a7f15fe440123",
      "invoiceDate": "2022-10-12",
      "complexity__c": "Middle",
      "description__c": "description"
    },
    {
      "id": "402890555a7e9791015a7f15fe44013a",
      "invoiceDate": "2022-10-12",
      "complexity__c": "Middle",
      "description__c": "description"
    },
    {
      "id": "402890555a7e9791015a7f15fe44012b",
      "invoiceDate": "2022-10-12",
      "complexity__c": "Middle",
      "description__c": "description"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/invoices/bulk-post");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"invoices\": [\n    {\n      \"id\": \"402890555a7e9791015a7f15fe440123\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    },\n    {\n      \"id\": \"402890555a7e9791015a7f15fe44013a\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    },\n    {\n      \"id\": \"402890555a7e9791015a7f15fe44012b\",\n      \"invoiceDate\": \"2022-10-12\",\n      \"complexity__c\": \"Middle\",\n      \"description__c\": \"description\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["invoices": [
    [
      "id": "402890555a7e9791015a7f15fe440123",
      "invoiceDate": "2022-10-12",
      "complexity__c": "Middle",
      "description__c": "description"
    ],
    [
      "id": "402890555a7e9791015a7f15fe44013a",
      "invoiceDate": "2022-10-12",
      "complexity__c": "Middle",
      "description__c": "description"
    ],
    [
      "id": "402890555a7e9791015a7f15fe44012b",
      "invoiceDate": "2022-10-12",
      "complexity__c": "Middle",
      "description__c": "description"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/invoices/bulk-post")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```